"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var isInDevMode = function () { return (!process.env.NODE_DEV || process.env.NODE_ENV === "development"); };
exports.buildQueryString = function (params) {
    if (!params) {
        return "";
    }
    var result = "";
    for (var key in params) {
        var value = params[key];
        if (value !== null && value !== undefined && value !== "") {
            if (Array.isArray(value)) {
                for (var i = 0; i < value.length; i++) {
                    result += "&" + key + "=" + value[i];
                }
            }
            else {
                result += "&" + key + "=" + value;
            }
        }
    }
    if (result) {
        result = result.substring(1);
    }
    return "" + result;
};
var statusCodes = {
    noContent: 204,
};
var stringifyBody = function (value) { return typeof (value) === "string" ? value : (value === null || value === undefined) ? null : JSON.stringify(value); };
var getDefaultHeaders = function () { return ({
    "Accept": "application/json",
    "Content-Type": "application/json",
}); };
var handleResponse = function (response) { return __awaiter(void 0, void 0, void 0, function () {
    var _isInDevMode, result, json, _a, error_1, error, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _isInDevMode = isInDevMode();
                result = {
                    ok: response.ok,
                    status: response.status,
                    isAborted: false,
                    value: undefined,
                    error: {}
                };
                if (!response.ok) return [3 /*break*/, 7];
                json = null;
                _b.label = 1;
            case 1:
                _b.trys.push([1, 5, , 6]);
                if (!(response.status === statusCodes.noContent)) return [3 /*break*/, 2];
                _a = null;
                return [3 /*break*/, 4];
            case 2: return [4 /*yield*/, response.json()];
            case 3:
                _a = _b.sent();
                _b.label = 4;
            case 4:
                json = _a;
                result.value = json;
                return [3 /*break*/, 6];
            case 5:
                error_1 = _b.sent();
                // JSON error
                result.error = error_1 || {};
                return [3 /*break*/, 6];
            case 6: return [2 /*return*/, result];
            case 7:
                error = null;
                _b.label = 8;
            case 8:
                _b.trys.push([8, 10, , 11]);
                return [4 /*yield*/, response.json()];
            case 9:
                error = (_b.sent()) || {};
                return [3 /*break*/, 11];
            case 10:
                err_1 = _b.sent();
                error = err_1;
                return [3 /*break*/, 11];
            case 11:
                _isInDevMode && console.error(error);
                result.error = error || {};
                return [2 /*return*/, result];
        }
    });
}); };
/**
 * @param {Error} error
 * @returns {HttpResponse}
 */
var catchError = function (error) {
    var isAborted = (error.name === "AbortError");
    !isAborted && isInDevMode() && console.error(error);
    return {
        ok: false,
        status: undefined,
        isAborted: isAborted,
        value: undefined,
        error: error
    };
};
var HttpRequest = /** @class */ (function () {
    function HttpRequest(method, props) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
        this._controller = new AbortController();
        this._abort = this._controller.abort.bind(this._controller);
        this._url = (((_a = props) === null || _a === void 0 ? void 0 : _a.url) || "");
        this._useDefaultHeaders = (((_c = (_b = props) === null || _b === void 0 ? void 0 : _b.configuration) === null || _c === void 0 ? void 0 : _c.useDefaultHeaders) === undefined ? true : Boolean((_e = (_d = props) === null || _d === void 0 ? void 0 : _d.configuration) === null || _e === void 0 ? void 0 : _e.useDefaultHeaders));
        this._stringifyBody = (((_g = (_f = props) === null || _f === void 0 ? void 0 : _f.configuration) === null || _g === void 0 ? void 0 : _g.stringifyBody) === undefined ? true : Boolean((_j = (_h = props) === null || _h === void 0 ? void 0 : _h.configuration) === null || _j === void 0 ? void 0 : _j.stringifyBody));
        this._allowMultiple = ((_l = (_k = props) === null || _k === void 0 ? void 0 : _k.configuration) === null || _l === void 0 ? void 0 : _l.allowMultiple) || false;
        this._isProcessing = false;
        this._headers = __assign(__assign({}, (this._useDefaultHeaders ? getDefaultHeaders() : {})), (((_m = props) === null || _m === void 0 ? void 0 : _m.headers) ? props.headers : {}));
        this._requestInit = {
            mode: "cors",
            method: method,
            credentials: (((_p = (_o = props) === null || _o === void 0 ? void 0 : _o.configuration) === null || _p === void 0 ? void 0 : _p.credentials) || "include"),
            headers: this._headers,
            body: (((_r = (_q = props) === null || _q === void 0 ? void 0 : _q.configuration) === null || _r === void 0 ? void 0 : _r.stringifyBody) === undefined || ((_s = props) === null || _s === void 0 ? void 0 : _s.configuration.stringifyBody) ? stringifyBody((_t = props) === null || _t === void 0 ? void 0 : _t.body) : (_u = props) === null || _u === void 0 ? void 0 : _u.body),
            signal: this._controller.signal
        };
    }
    Object.defineProperty(HttpRequest.prototype, "url", {
        get: function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(HttpRequest.prototype, "headers", {
        get: function () {
            return this._headers;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(HttpRequest.prototype, "body", {
        get: function () {
            return this._requestInit.body;
        },
        enumerable: true,
        configurable: true
    });
    ;
    HttpRequest.prototype.withUrl = function (value) {
        this._url = value;
        return this;
    };
    ;
    HttpRequest.prototype.withHeaders = function (value) {
        this._headers = __assign(__assign({}, (this._useDefaultHeaders ? getDefaultHeaders() : {})), value);
        return this;
    };
    ;
    HttpRequest.prototype.withBody = function (value) {
        this._requestInit.body = (this._stringifyBody ? stringifyBody(value) : value);
        return this;
    };
    ;
    HttpRequest.prototype.addHeaders = function (value) {
        this._headers = __assign(__assign({}, this._headers), value);
    };
    ;
    HttpRequest.prototype.patchHeaders = function (value) {
        for (var key in value) {
            if (this._headers.hasOwnProperty(key)) {
                this._headers[key] = value[key];
            }
        }
    };
    ;
    HttpRequest.prototype.removeHeader = function (key) {
        var itemExists = this._headers.hasOwnProperty(key);
        if (itemExists) {
            delete this._headers[key];
        }
        return itemExists;
    };
    ;
    HttpRequest.prototype.execute = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._allowMultiple && this._isProcessing) {
                            isInDevMode() && console.warn("A httpRequest instance can only send one request at the same time. If you wish to remove this constraint, you can set the \"allowMultiple\" attribute in configuration to true.");
                            return [2 /*return*/, {
                                    ok: false,
                                    status: undefined,
                                    isAborted: true,
                                    value: undefined,
                                    error: {}
                                }];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        this._isProcessing = true;
                        this._requestInit.headers = this._headers;
                        return [4 /*yield*/, fetch(this._url, this._requestInit)];
                    case 2:
                        response = _a.sent();
                        this._isProcessing = false;
                        return [4 /*yield*/, handleResponse(response)];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4:
                        error_2 = _a.sent();
                        this._isProcessing = false;
                        return [2 /*return*/, catchError(error_2)];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    ;
    HttpRequest.prototype.abort = function () {
        this._abort();
        this._controller = new AbortController();
        this._abort = this._controller.abort.bind(this._controller);
        this._requestInit.signal = this._controller.signal;
    };
    ;
    return HttpRequest;
}());
;
var getDefaultProps = function () { return ({
    url: "",
    headers: {},
    body: null,
    configuration: undefined
}); };
exports.httpGet = function (props) {
    if (props === void 0) { props = getDefaultProps(); }
    return new HttpRequest("get", props);
};
exports.httpPost = function (props) {
    if (props === void 0) { props = getDefaultProps(); }
    return new HttpRequest("post", props);
};
exports.httpPut = function (props) {
    if (props === void 0) { props = getDefaultProps(); }
    return new HttpRequest("put", props);
};
exports.httpDelete = function (props) {
    if (props === void 0) { props = getDefaultProps(); }
    return new HttpRequest("delete", props);
};
